Index: src/ResolvExpr/Alternative.cc
===================================================================
--- src/ResolvExpr/Alternative.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/ResolvExpr/Alternative.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -34,36 +34,4 @@
 	Alternative::Alternative( Expression *expr, const TypeEnvironment &env, const Cost& cost, const Cost &cvtCost )
 		: cost( cost ), cvtCost( cvtCost ), expr( expr ), env( env ) {}
-
-	Alternative::Alternative( const Alternative &other ) : cost( other.cost ), cvtCost( other.cvtCost ), expr( maybeClone( other.expr ) ), env( other.env ) {
-	}
-
-	Alternative &Alternative::operator=( const Alternative &other ) {
-		if ( &other == this ) return *this;
-		delete expr;
-		cost = other.cost;
-		cvtCost = other.cvtCost;
-		expr = maybeClone( other.expr );
-		env = other.env;
-		return *this;
-	}
-
-	Alternative::Alternative( Alternative && other ) : cost( other.cost ), cvtCost( other.cvtCost ), expr( other.expr ), env( other.env ) {
-		other.expr = nullptr;
-	}
-
-	Alternative & Alternative::operator=( Alternative && other ) {
-		if ( &other == this )  return *this;
-		delete expr;
-		cost = other.cost;
-		cvtCost = other.cvtCost;
-		expr = other.expr;
-		env = other.env;
-		other.expr = nullptr;
-		return *this;
-	}
-
-	Alternative::~Alternative() {
-		delete expr;
-	}
 
 	void Alternative::print( std::ostream &os, Indenter indent ) const {
Index: src/ResolvExpr/Alternative.h
===================================================================
--- src/ResolvExpr/Alternative.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/ResolvExpr/Alternative.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -29,22 +29,12 @@
 		Alternative( Expression *expr, const TypeEnvironment &env, const Cost &cost );
 		Alternative( Expression *expr, const TypeEnvironment &env, const Cost &cost, const Cost &cvtCost );
-		Alternative( const Alternative &other );
-		Alternative &operator=( const Alternative &other );
-		Alternative( Alternative && other );
-		Alternative &operator=( Alternative && other );
-		~Alternative();
+		Alternative( const Alternative &other ) = default;
+		Alternative &operator=( const Alternative &other ) = default;
 
 		void print( std::ostream &os, Indenter indent = {} ) const;
 
-		/// Returns the stored expression, but released from management of this Alternative
-		Expression* release_expr() {
-			Expression* tmp = expr;
-			expr = nullptr;
-			return tmp;
-		}
-
 		Cost cost;
 		Cost cvtCost;
-		Expression *expr;
+		Expression * expr;
 		TypeEnvironment env;
 	};
Index: src/ResolvExpr/AlternativeFinder.cc
===================================================================
--- src/ResolvExpr/AlternativeFinder.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/ResolvExpr/AlternativeFinder.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -165,5 +165,4 @@
 					candidate->env.apply( newType );
 					mangleName = SymTab::Mangler::mangle( newType );
-					delete newType;
 				}
 				std::map< std::string, PruneStruct >::iterator mapPlace = selected.find( mangleName );
@@ -568,5 +567,4 @@
 
 				Expression *varExpr = data.combine( newerAlt.cvtCost );
-				delete varExpr->get_result();
 				varExpr->set_result( adjType->clone() );
 				PRINT(
@@ -585,6 +583,4 @@
 				(*inferParameters)[ curDecl->get_uniqueId() ] = ParamEntry( candidate->get_uniqueId(), adjType->clone(), curDecl->get_type()->clone(), varExpr );
 				inferRecursive( begin, end, newerAlt, newOpenVars, newDecls, newerNeed, /*newNeedParents,*/ level, indexer, out );
-			} else {
-				delete adjType;
 			}
 		}
@@ -1264,5 +1260,4 @@
 				componentExprs.push_back( restructureCast( idx, toType->getComponent( i ) ) );
 			}
-			delete argExpr;
 			assert( componentExprs.size() > 0 );
 			// produce the tuple of casts
@@ -1600,5 +1595,4 @@
 			alternatives.push_back( Alternative( new CommaExpr( newFirstArg->clone(), alt.expr->clone() ), alt.env, alt.cost ) );
 		} // for
-		delete newFirstArg;
 	}
 
Index: src/ResolvExpr/ResolveTypeof.cc
===================================================================
--- src/ResolvExpr/ResolveTypeof.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/ResolvExpr/ResolveTypeof.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -70,9 +70,5 @@
 			Expression * newExpr = resolveInVoidContext( typeofType->expr, indexer );
 			assert( newExpr->result && ! newExpr->result->isVoid() );
-			Type * newType = newExpr->result;
-			newExpr->result = nullptr;
-			delete typeofType;
-			delete newExpr;
-			return newType;
+			return newExpr->result;
 		} // if
 		return typeofType;
Index: src/ResolvExpr/Resolver.cc
===================================================================
--- src/ResolvExpr/Resolver.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/ResolvExpr/Resolver.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -138,5 +138,4 @@
 					castExpr->arg = nullptr;
 					std::swap( expr->env, castExpr->env );
-					delete castExpr;
 				}
 			}
@@ -198,5 +197,4 @@
 			findUnfinishedKindExpression( untyped, choice, indexer, kindStr, pred, adjust, prune, failFast );
 			finishExpr( choice.expr, choice.env, untyped->env );
-			delete untyped;
 			untyped = choice.expr;
 			choice.expr = nullptr;
@@ -244,5 +242,4 @@
 		Expression * newExpr = resolveInVoidContext( untyped, indexer, env );
 		finishExpr( newExpr, env, untyped->env );
-		delete untyped;
 		untyped = newExpr;
 	}
@@ -418,5 +415,4 @@
 			caseStmt->condition = castExpr->arg;
 			castExpr->arg = nullptr;
-			delete castExpr;
 		}
 	}
@@ -700,5 +696,4 @@
 		std::swap( initExpr->env, newExpr->env );
 		std::swap( initExpr->inferParams, newExpr->inferParams ) ;
-		delete initExpr;
 
 		// get the actual object's type (may not exactly match what comes back from the resolver due to conversions)
@@ -718,5 +713,4 @@
 							ce->set_arg( nullptr );
 							std::swap( ce->env, newExpr->env );
-							delete ce;
 						}
 					}
@@ -769,8 +763,6 @@
 		// could not find valid constructor, or found an intrinsic constructor
 		// fall back on C-style initializer
-		delete ctorInit->get_ctor();
-		ctorInit->set_ctor( NULL );
-		delete ctorInit->get_dtor();
-		ctorInit->set_dtor( NULL );
+		ctorInit->set_ctor( nullptr );
+		ctorInit->set_dtor( nullptr );
 		maybeAccept( ctorInit->get_init(), *visitor );
 	}
@@ -798,5 +790,4 @@
 
 		// found a constructor - can get rid of C-style initializer
-		delete ctorInit->init;
 		ctorInit->init = nullptr;
 
@@ -805,10 +796,8 @@
 		// to clean up generated code.
 		if ( InitTweak::isIntrinsicSingleArgCallStmt( ctorInit->ctor ) ) {
-			delete ctorInit->ctor;
 			ctorInit->ctor = nullptr;
 		}
 
 		if ( InitTweak::isIntrinsicSingleArgCallStmt( ctorInit->dtor ) ) {
-			delete ctorInit->dtor;
 			ctorInit->dtor = nullptr;
 		}
Index: src/ResolvExpr/TypeEnvironment.cc
===================================================================
--- src/ResolvExpr/TypeEnvironment.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/ResolvExpr/TypeEnvironment.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -59,11 +59,6 @@
 	EqvClass &EqvClass::operator=( const EqvClass &other ) {
 		if ( this == &other ) return *this;
-		delete type;
 		initialize( other, *this );
 		return *this;
-	}
-
-	EqvClass::~EqvClass() {
-		delete type;
 	}
 
@@ -147,5 +142,4 @@
 ///         std::cerr << " bound to variable " << *theClass->vars.begin() << std::endl;
 					sub.add( *theVar, newTypeInst );
-					delete newTypeInst;
 				} // if
 			} // for
@@ -188,7 +182,5 @@
 					if ( secondClass->type ) {
 						if ( newClass.type ) {
-							Type *newType = combineFunc( newClass.type, secondClass->type );
-							delete newClass.type;
-							newClass.type = newType;
+							newClass.type = combineFunc( newClass.type, secondClass->type );
 							newClass.allowWidening = newClass.allowWidening && secondClass->allowWidening;
 						} else {
Index: src/ResolvExpr/TypeEnvironment.h
===================================================================
--- src/ResolvExpr/TypeEnvironment.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/ResolvExpr/TypeEnvironment.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -67,5 +67,4 @@
 		EqvClass( const EqvClass &other );
 		EqvClass &operator=( const EqvClass &other );
-		~EqvClass();
 		void print( std::ostream &os, Indenter indent = {} ) const;
 	};
Index: src/ResolvExpr/Unify.cc
===================================================================
--- src/ResolvExpr/Unify.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/ResolvExpr/Unify.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -99,8 +99,5 @@
 		findOpenVars( newSecond, openVars, closedVars, needAssertions, haveAssertions, true );
 
-		bool result = unifyExact( newFirst, newSecond, newEnv, needAssertions, haveAssertions, openVars, WidenMode( false, false ), indexer );
-		delete newFirst;
-		delete newSecond;
-		return result;
+		return unifyExact( newFirst, newSecond, newEnv, needAssertions, haveAssertions, openVars, WidenMode( false, false ), indexer );
 	}
 
@@ -123,8 +120,5 @@
 ///   newSecond->print( std::cerr );
 ///   std::cerr << std::endl;
-		bool result = unifyExact( newFirst, newSecond, newEnv, needAssertions, haveAssertions, openVars, WidenMode( false, false ), indexer );
-		delete newFirst;
-		delete newSecond;
-		return result;
+		return unifyExact( newFirst, newSecond, newEnv, needAssertions, haveAssertions, openVars, WidenMode( false, false ), indexer );
 	}
 
@@ -176,5 +170,4 @@
 					if ( common ) {
 						common->get_qualifiers() = Type::Qualifiers();
-						delete curClass.type;
 						curClass.type = common;
 						env.add( curClass );
@@ -239,5 +232,4 @@
 				if ( common ) {
 					common->get_qualifiers() = Type::Qualifiers();
-					delete class1.type;
 					class1.type = common;
 				} // if
@@ -272,6 +264,4 @@
 			env.add( newClass );
 		} // if
-		delete type1;
-		delete type2;
 		return result;
 	}
@@ -282,12 +272,5 @@
 		findOpenVars( type2, openVars, closedVars, needAssertions, haveAssertions, true );
 		Type *commonType = 0;
-		if ( unifyInexact( type1, type2, env, needAssertions, haveAssertions, openVars, WidenMode( true, true ), indexer, commonType ) ) {
-			if ( commonType ) {
-				delete commonType;
-			} // if
-			return true;
-		} else {
-			return false;
-		} // if
+		return unifyInexact( type1, type2, env, needAssertions, haveAssertions, openVars, WidenMode( true, true ), indexer, commonType );
 	}
 
@@ -544,5 +527,4 @@
 					// expand ttype parameter into its actual type
 					if ( eqvClass.type ) {
-						delete typeInst;
 						return eqvClass.type->clone();
 					}
@@ -569,5 +551,4 @@
 				dst.push_back( new ObjectDecl( "", Type::StorageClasses(), LinkageSpec::C, nullptr, t, nullptr ) );
 			}
-			delete dcl;
 		}
 	}
Index: src/ResolvExpr/Unify.h
===================================================================
--- src/ResolvExpr/Unify.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/ResolvExpr/Unify.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -64,10 +64,5 @@
 	bool unifyList( Iterator1 list1Begin, Iterator1 list1End, Iterator2 list2Begin, Iterator2 list2End, TypeEnvironment &env, AssertionSet &needAssertions, AssertionSet &haveAssertions, OpenVarSet &openVars, const SymTab::Indexer &indexer ) {
 		std::list< Type* > commonTypes;
-		if ( unifyList( list1Begin, list1End, list2Begin, list2End, env, needAssertions, haveAssertions, openVars, indexer, commonTypes ) ) {
-			deleteAll( commonTypes );
-			return true;
-		} else {
-			return false;
-		} // if
+		return unifyList( list1Begin, list1End, list2Begin, list2End, env, needAssertions, haveAssertions, openVars, indexer, commonTypes );
 	}
 
Index: src/SymTab/Autogen.cc
===================================================================
--- src/SymTab/Autogen.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SymTab/Autogen.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -214,5 +214,4 @@
 	void addForwardDecl( FunctionDecl * functionDecl, std::list< Declaration * > & declsToAdd ) {
 		FunctionDecl * decl = functionDecl->clone();
-		delete decl->statements;
 		decl->statements = nullptr;
 		declsToAdd.push_back( decl );
@@ -333,5 +332,4 @@
 		} catch ( SemanticErrorException err ) {
 			// okay if decl does not resolve - that means the function should not be generated
-			delete dcl;
 		}
 	}
@@ -373,5 +371,4 @@
 			// do not carry over field's attributes to parameter type
 			Type * paramType = field->get_type()->clone();
-			deleteAll( paramType->attributes );
 			paramType->attributes.clear();
 			// add a parameter corresponding to this field
@@ -383,5 +380,4 @@
 			resolve( ctor );
 		}
-		delete memCtorType;
 	}
 
@@ -511,5 +507,4 @@
 			// do not carry over field's attributes to parameter type
 			Type * paramType = field->get_type()->clone();
-			deleteAll( paramType->attributes );
 			paramType->attributes.clear();
 			// add a parameter corresponding to this field
@@ -524,5 +519,4 @@
 			break;
 		}
-		delete memCtorType;
 	}
 
Index: src/SymTab/Autogen.h
===================================================================
--- src/SymTab/Autogen.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SymTab/Autogen.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -97,5 +97,4 @@
 		// return if adding reference fails - will happen on default constructor and destructor
 		if ( isReferenceCtorDtor && ! srcParam.addReference() ) {
-			delete fExpr;
 			return listInit;
 		}
Index: src/SymTab/FixFunction.cc
===================================================================
--- src/SymTab/FixFunction.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SymTab/FixFunction.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -28,10 +28,8 @@
 
 	DeclarationWithType * FixFunction::postmutate(FunctionDecl *functionDecl) {
-		// can't delete function type because it may contain assertions, so transfer ownership to new object
-		ObjectDecl *pointer = new ObjectDecl( functionDecl->name, functionDecl->get_storageClasses(), functionDecl->linkage, nullptr, new PointerType( Type::Qualifiers(), functionDecl->type ), nullptr, functionDecl->attributes );
-		functionDecl->attributes.clear();
-		functionDecl->type = nullptr;
-		delete functionDecl;
-		return pointer;
+		return new ObjectDecl{ 
+			functionDecl->name, functionDecl->get_storageClasses(), functionDecl->linkage, nullptr, 
+			new PointerType{ Type::Qualifiers(), functionDecl->type }, 
+			nullptr, functionDecl->attributes };
 	}
 
@@ -42,9 +40,5 @@
 	Type * FixFunction::postmutate(ArrayType *arrayType) {
 		// need to recursively mutate the base type in order for multi-dimensional arrays to work.
-		PointerType *pointerType = new PointerType( arrayType->get_qualifiers(), arrayType->base, arrayType->dimension, arrayType->isVarLen, arrayType->isStatic );
-		arrayType->base = nullptr;
-		arrayType->dimension = nullptr;
-		delete arrayType;
-		return pointerType;
+		return new PointerType{ arrayType->get_qualifiers(), arrayType->base, arrayType->dimension, arrayType->isVarLen, arrayType->isStatic };
 	}
 
Index: src/SymTab/Validate.cc
===================================================================
--- src/SymTab/Validate.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SymTab/Validate.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -310,5 +310,5 @@
 		} // if
 		// Always remove the hoisted aggregate from the inner structure.
-		GuardAction( [aggregateDecl]() { filter( aggregateDecl->members, isStructOrUnion, false ); } );
+		GuardAction( [aggregateDecl]() { filter( aggregateDecl->members, isStructOrUnion ); } );
 	}
 
@@ -365,5 +365,4 @@
 			// one void is the only thing in the list; remove it.
 			if ( containsVoid ) {
-				delete dwts.front();
 				dwts.clear();
 			}
@@ -492,5 +491,4 @@
 				}
 			}
-			deleteAll( td->assertions );
 			td->assertions.clear();
 		} // for
@@ -608,5 +606,4 @@
 					// expand trait instance into all of its members
 					expandAssertions( traitInst, back_inserter( type->assertions ) );
-					delete traitInst;
 				} else {
 					// pass other assertions through
@@ -682,5 +679,5 @@
 			SizeType = new BasicType( Type::Qualifiers(), BasicType::LongUnsignedInt );
 		}
-		filter( translationUnit, isTypedef, true );
+		filter( translationUnit, isTypedef );
 	}
 
@@ -696,5 +693,4 @@
 				ret->attributes.splice( ret->attributes.end(), typeInst->attributes );
 			} else {
-				deleteAll( ret->attributes );
 				ret->attributes.clear();
 			}
@@ -709,5 +705,4 @@
 				mutateAll( rtt->parameters, *visitor );  // recursively fix typedefs on parameters
 			} // if
-			delete typeInst;
 			return ret;
 		} else {
@@ -795,9 +790,7 @@
 		if ( FunctionType *funtype = dynamic_cast<FunctionType *>( objDecl->get_type() ) ) { // function type?
 			// replace the current object declaration with a function declaration
-			FunctionDecl * newDecl = new FunctionDecl( objDecl->get_name(), objDecl->get_storageClasses(), objDecl->get_linkage(), funtype, 0, objDecl->get_attributes(), objDecl->get_funcSpec() );
-			objDecl->get_attributes().clear();
-			objDecl->set_type( nullptr );
-			delete objDecl;
-			return newDecl;
+			return new FunctionDecl{ 
+				objDecl->get_name(), objDecl->get_storageClasses(), objDecl->get_linkage(), 
+				funtype, 0, objDecl->get_attributes(), objDecl->get_funcSpec() };
 		} // if
 		return objDecl;
@@ -823,5 +816,5 @@
 			} // if
 			return false;
-		}, true);
+		} );
 		return compoundStmt;
 	}
@@ -831,5 +824,5 @@
 	template<typename AggDecl>
 	AggDecl *EliminateTypedef::handleAggregate( AggDecl * aggDecl ) {
-		filter( aggDecl->members, isTypedef, true );
+		filter( aggDecl->members, isTypedef );
 		return aggDecl;
 	}
@@ -961,8 +954,6 @@
 		static UniqueName indexName( "_compLit" );
 
-		ObjectDecl *tempvar = new ObjectDecl( indexName.newName(), storageClasses, LinkageSpec::C, nullptr, compLitExpr->get_result(), compLitExpr->get_initializer() );
-		compLitExpr->set_result( nullptr );
-		compLitExpr->set_initializer( nullptr );
-		delete compLitExpr;
+		ObjectDecl * tempvar = new ObjectDecl{ 
+			indexName.newName(), storageClasses, LinkageSpec::C, nullptr, compLitExpr->get_result(), compLitExpr->get_initializer() };
 		declsToAddBefore.push_back( tempvar );					// add modified temporary to current block
 		return new VariableExpr( tempvar );
@@ -1000,5 +991,4 @@
 			// ensure return value is not destructed by explicitly creating an empty ListInit node wherein maybeConstruct is false.
 			ObjectDecl * newRet = new ObjectDecl( "", Type::StorageClasses(), LinkageSpec::Cforall, 0, tupleType, new ListInit( std::list<Initializer*>(), noDesignators, false ) );
-			deleteAll( retVals );
 			retVals.clear();
 			retVals.push_back( newRet );
@@ -1041,7 +1031,5 @@
 			if ( NameExpr * nameExpr = dynamic_cast< NameExpr * >( inner->arg ) ) {
 				if ( labels.count( nameExpr->name ) ) {
-					Label name = nameExpr->name;
-					delete addrExpr;
-					return new LabelAddressExpr( name );
+					return new LabelAddressExpr{ nameExpr->name };
 				}
 			}
Index: src/SynTree/AddressExpr.cc
===================================================================
--- src/SynTree/AddressExpr.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/AddressExpr.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -58,8 +58,4 @@
 }
 
-AddressExpr::~AddressExpr() {
-	delete arg;
-}
-
 void AddressExpr::print( std::ostream &os, Indenter indent ) const {
 	os << "Address of:" << std::endl;
@@ -75,5 +71,4 @@
 }
 LabelAddressExpr::LabelAddressExpr( const LabelAddressExpr & other ) : Expression( other ), arg( other.arg ) {}
-LabelAddressExpr::~LabelAddressExpr() {}
 
 void LabelAddressExpr::print( std::ostream & os, Indenter ) const {
Index: src/SynTree/AggregateDecl.cc
===================================================================
--- src/SynTree/AggregateDecl.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/AggregateDecl.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -33,10 +33,4 @@
 	cloneAll( other.attributes, attributes );
 	body = other.body;
-}
-
-AggregateDecl::~AggregateDecl() {
-	deleteAll( attributes );
-	deleteAll( parameters );
-	deleteAll( members );
 }
 
Index: src/SynTree/ApplicationExpr.cc
===================================================================
--- src/SynTree/ApplicationExpr.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/ApplicationExpr.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -43,10 +43,4 @@
 }
 
-ParamEntry::~ParamEntry() {
-	delete actualType;
-	delete formalType;
-	delete expr;
-}
-
 ApplicationExpr::ApplicationExpr( Expression *funcExpr, const std::list<Expression *> & args ) : function( funcExpr ), args( args ) {
 	PointerType *pointer = strict_dynamic_cast< PointerType* >( funcExpr->get_result() );
@@ -61,9 +55,4 @@
 		Expression( other ), function( maybeClone( other.function ) ) {
 	cloneAll( other.args, args );
-}
-
-ApplicationExpr::~ApplicationExpr() {
-	delete function;
-	deleteAll( args );
 }
 
Index: src/SynTree/ArrayType.cc
===================================================================
--- src/SynTree/ArrayType.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/ArrayType.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -34,9 +34,4 @@
 }
 
-ArrayType::~ArrayType() {
-	delete base;
-	delete dimension;
-}
-
 void ArrayType::print( std::ostream &os, Indenter indent ) const {
 	Type::print( os, indent );
Index: src/SynTree/AttrType.cc
===================================================================
--- src/SynTree/AttrType.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/AttrType.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -37,9 +37,4 @@
 }
 
-AttrType::~AttrType() {
-	delete expr;
-	delete type;
-}
-
 void AttrType::print( std::ostream &os, Indenter indent ) const {
 	Type::print( os, indent );
Index: src/SynTree/Attribute.cc
===================================================================
--- src/SynTree/Attribute.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/Attribute.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -23,8 +23,4 @@
 Attribute::Attribute( const Attribute &other ) : name( other.name ) {
 	cloneAll( other.parameters, parameters );
-}
-
-Attribute::~Attribute() {
-	deleteAll( parameters );
 }
 
Index: src/SynTree/Attribute.h
===================================================================
--- src/SynTree/Attribute.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/Attribute.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -36,5 +36,4 @@
 	Attribute( std::string name = "", const std::list< Expression * > & parameters = std::list< Expression * >() ) : name( name ), parameters( parameters ) {}
 	Attribute( const Attribute &other );
-	virtual ~Attribute();
 
 	std::string get_name() const { return name; }
Index: src/SynTree/BaseSyntaxNode.h
===================================================================
--- src/SynTree/BaseSyntaxNode.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/BaseSyntaxNode.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -17,13 +17,13 @@
 
 #include "Common/CodeLocation.h"
+#include "Common/GC.h"
 #include "Common/Indenter.h"
+
 class Visitor;
 class Mutator;
 
-class BaseSyntaxNode {
-  public:
+class BaseSyntaxNode : GC_Object {
+public:
 	CodeLocation location;
-
-	virtual ~BaseSyntaxNode() {}
 
 	virtual BaseSyntaxNode * clone() const = 0;
Index: src/SynTree/CommaExpr.cc
===================================================================
--- src/SynTree/CommaExpr.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/CommaExpr.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -34,9 +34,4 @@
 }
 
-CommaExpr::~CommaExpr() {
-	delete arg1;
-	delete arg2;
-}
-
 void CommaExpr::print( std::ostream &os, Indenter indent ) const {
 	os << "Comma Expression:" << std::endl;
Index: src/SynTree/CompoundStmt.cc
===================================================================
--- src/SynTree/CompoundStmt.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/CompoundStmt.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -68,8 +68,4 @@
 }
 
-CompoundStmt::~CompoundStmt() {
-	deleteAll( kids );
-}
-
 void CompoundStmt::print( std::ostream &os, Indenter indent ) const {
 	os << "CompoundStmt" << endl;
Index: src/SynTree/Constant.cc
===================================================================
--- src/SynTree/Constant.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/Constant.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -27,6 +27,4 @@
 	type = other.type->clone();
 }
-
-Constant::~Constant() { delete type; }
 
 Constant Constant::from_bool( bool b ) {
Index: src/SynTree/Constant.h
===================================================================
--- src/SynTree/Constant.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/Constant.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -30,6 +30,5 @@
 	Constant( Type * type, std::string rep, double val );
 	Constant( const Constant & other );
-	virtual ~Constant();
-
+	
 	virtual Constant * clone() const { return new Constant( *this ); }
 
Index: src/SynTree/DeclStmt.cc
===================================================================
--- src/SynTree/DeclStmt.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/DeclStmt.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -29,8 +29,4 @@
 }
 
-DeclStmt::~DeclStmt() {
-	delete decl;
-}
-
 void DeclStmt::print( std::ostream &os, Indenter indent ) const {
 	assert( decl != 0 );
Index: src/SynTree/Declaration.cc
===================================================================
--- src/SynTree/Declaration.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/Declaration.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -38,7 +38,4 @@
 }
 
-Declaration::~Declaration() {
-}
-
 void Declaration::fixUniqueId() {
 	// don't need to set unique ID twice
@@ -68,8 +65,4 @@
 }
 
-AsmDecl::~AsmDecl() {
-	delete stmt;
-}
-
 void AsmDecl::print( std::ostream &os, Indenter indent ) const {
 	stmt->print( os, indent );
Index: src/SynTree/Declaration.h
===================================================================
--- src/SynTree/Declaration.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/Declaration.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -45,5 +45,4 @@
 	Declaration( const std::string &name, Type::StorageClasses scs, LinkageSpec::Spec linkage );
 	Declaration( const Declaration &other );
-	virtual ~Declaration();
 
 	const std::string &get_name() const { return name; }
@@ -87,6 +86,5 @@
 	DeclarationWithType( const std::string &name, Type::StorageClasses scs, LinkageSpec::Spec linkage, const std::list< Attribute * > & attributes, Type::FuncSpecifiers fs );
 	DeclarationWithType( const DeclarationWithType &other );
-	virtual ~DeclarationWithType();
-
+	
 	std::string get_mangleName() const { return mangleName; }
 	DeclarationWithType * set_mangleName( std::string newValue ) { mangleName = newValue; return this; }
@@ -126,5 +124,4 @@
 				const std::list< Attribute * > attributes = std::list< Attribute * >(), Type::FuncSpecifiers fs = Type::FuncSpecifiers() );
 	ObjectDecl( const ObjectDecl &other );
-	virtual ~ObjectDecl();
 
 	virtual Type * get_type() const override { return type; }
@@ -156,5 +153,4 @@
 				  const std::list< Attribute * > attributes = std::list< Attribute * >(), Type::FuncSpecifiers fs = Type::FuncSpecifiers() );
 	FunctionDecl( const FunctionDecl &other );
-	virtual ~FunctionDecl();
 
 	virtual Type * get_type() const override { return type; }
@@ -184,5 +180,4 @@
 	NamedTypeDecl( const std::string &name, Type::StorageClasses scs, Type *type );
 	NamedTypeDecl( const NamedTypeDecl &other );
-	virtual ~NamedTypeDecl();
 
 	Type *get_base() const { return base; }
@@ -219,5 +214,4 @@
 	TypeDecl( const std::string &name, Type::StorageClasses scs, Type *type, Kind kind, bool sized, Type * init = nullptr );
 	TypeDecl( const TypeDecl &other );
-	virtual ~TypeDecl();
 
 	Kind get_kind() const { return kind; }
@@ -268,6 +262,5 @@
 	AggregateDecl( const std::string &name, const std::list< Attribute * > & attributes = std::list< class Attribute * >(), LinkageSpec::Spec linkage = LinkageSpec::Cforall );
 	AggregateDecl( const AggregateDecl &other );
-	virtual ~AggregateDecl();
-
+	
 	std::list<Declaration*>& get_members() { return members; }
 	std::list<TypeDecl*>& get_parameters() { return parameters; }
@@ -353,5 +346,4 @@
 	AsmDecl( AsmStmt *stmt );
 	AsmDecl( const AsmDecl &other );
-	virtual ~AsmDecl();
 
 	AsmStmt *get_stmt() { return stmt; }
Index: src/SynTree/DeclarationWithType.cc
===================================================================
--- src/SynTree/DeclarationWithType.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/DeclarationWithType.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -34,9 +34,4 @@
 }
 
-DeclarationWithType::~DeclarationWithType() {
-	deleteAll( attributes );
-	delete asmName;
-}
-
 // Local Variables: //
 // tab-width: 4 //
